searchData={"items":[{"type":"module","title":"OffBroadwayWebSocket.Client","doc":"Provides functions to establish and configure WebSocket connections\nusing the **gun** library, with customizable timeouts and connection options.","ref":"OffBroadwayWebSocket.Client.html"},{"type":"function","title":"OffBroadwayWebSocket.Client.connect/5","doc":"Establishes a WebSocket connection to the specified URL and path with optional **gun** options,\nand customizable timeouts.","ref":"OffBroadwayWebSocket.Client.html#connect/5"},{"type":"function","title":"Parameters - OffBroadwayWebSocket.Client.connect/5","doc":"- **url**: The base URL for the WebSocket connection (e.g., \"wss://example.com\").\n  - **path**: The WebSocket path to upgrade to (e.g., \"/ws\").\n  - **gun_opts**: A tuple **{http_opts, ws_opts}** containing optional configurations for HTTP\n    and WebSocket settings. Either **http_opts** or **ws_opts** may be **nil**.\n  - **await_timeout**: The timeout in milliseconds to wait for the connection to become ready.\n  - **connect_timeout**: The timeout in milliseconds for establishing the connection.","ref":"OffBroadwayWebSocket.Client.html#connect/5-parameters"},{"type":"function","title":"Returns - OffBroadwayWebSocket.Client.connect/5","doc":"- **{:ok, %{conn_pid: pid(), stream_ref: reference()}}** on a successful connection and upgrade.\n  - **{:error, reason}** if the connection or upgrade fails.","ref":"OffBroadwayWebSocket.Client.html#connect/5-returns"},{"type":"module","title":"OffBroadwayWebSocket.Producer","doc":"A GenStage producer that manages WebSocket connections using the **gun** library.\n\nThis module establishes a WebSocket connection, and manages message dispatching based on demand. It monitors the\nWebSocket connection with ping/pong messages and terminates connection when timeouts occur.","ref":"OffBroadwayWebSocket.Producer.html"},{"type":"function","title":"OffBroadwayWebSocket.Producer.dispatch_events/2","doc":"","ref":"OffBroadwayWebSocket.Producer.html#dispatch_events/2"},{"type":"function","title":"OffBroadwayWebSocket.Producer.on_ws_timeout/1","doc":"Closes the connection and schedules a reconnect on WebSocket timeout.","ref":"OffBroadwayWebSocket.Producer.html#on_ws_timeout/1"},{"type":"function","title":"OffBroadwayWebSocket.Producer.start_link/1","doc":"","ref":"OffBroadwayWebSocket.Producer.html#start_link/1"},{"type":"module","title":"OffBroadwayWebSocket.State","doc":"Manages the state for WebSocket producer in an Off-Broadway setup.\nThis includes demand tracking, reconnection parameters, and message queuing.","ref":"OffBroadwayWebSocket.State.html"},{"type":"function","title":"OffBroadwayWebSocket.State.new/1","doc":"Creates a new **%State{}** struct with specified options.","ref":"OffBroadwayWebSocket.State.html#new/1"},{"type":"function","title":"Parameters - OffBroadwayWebSocket.State.new/1","doc":"- **opts**: A keyword list of options, including:\n    - **:broadway** - Broadway-related options, specifically demand settings.\n    - **:url** - The WebSocket URL.\n    - **:path** - The WebSocket path.\n    - **:reconnect_delay** - Optional delay in milliseconds for reconnection.\n    - **:ws_opts** - WebSocket options for **gun**.\n    - **:http_opts** - HTTP options for **gun**.\n    - **:ws_timeout** - Optional timeout for WebSocket operations.","ref":"OffBroadwayWebSocket.State.html#new/1-parameters"},{"type":"function","title":"Returns - OffBroadwayWebSocket.State.new/1","doc":"- A **%State{}** struct initialized with the provided options and default values.","ref":"OffBroadwayWebSocket.State.html#new/1-returns"},{"type":"type","title":"OffBroadwayWebSocket.State.t/0","doc":"","ref":"OffBroadwayWebSocket.State.html#t:t/0"},{"type":"module","title":"OffBroadwayWebSocket.Utils","doc":"Utility module for managing a queue with demand-based operations.","ref":"OffBroadwayWebSocket.Utils.html"},{"type":"function","title":"OffBroadwayWebSocket.Utils.on_demand/4","doc":"Processes demand on the queue based on specified thresholds.\n\nIf **size** is greater than or equal to **min_demand**, the function will attempt to\npop up to **demand** items from the queue. If the **size** is less than **min_demand**,\nit returns an empty response.","ref":"OffBroadwayWebSocket.Utils.html#on_demand/4"},{"type":"function","title":"Parameters - OffBroadwayWebSocket.Utils.on_demand/4","doc":"- **queue**: The queue from which to pull items (of type **:queue.queue()**).\n  - **min_demand**: The minimum demand threshold (non-negative integer).\n  - **size**: The current size of the queue (non-negative integer).\n  - **demand**: The number of items requested (non-negative integer).","ref":"OffBroadwayWebSocket.Utils.html#on_demand/4-parameters"},{"type":"function","title":"Returns - OffBroadwayWebSocket.Utils.on_demand/4","doc":"- A tuple **{count, items, new_queue}** where:\n    - **count** is the number of items actually returned (non-negative integer).\n    - **items** is a list of items retrieved from the queue.\n    - **new_queue** is the updated queue after the demand is processed.","ref":"OffBroadwayWebSocket.Utils.html#on_demand/4-returns"},{"type":"function","title":"OffBroadwayWebSocket.Utils.pop_n/2","doc":"Retrieves up to **n** items from the queue.\n\nThis function attempts to pop **n** items from the given queue. If the queue has fewer\nthan **n** items, it retrieves as many as possible.","ref":"OffBroadwayWebSocket.Utils.html#pop_n/2"},{"type":"function","title":"Parameters - OffBroadwayWebSocket.Utils.pop_n/2","doc":"- **queue**: The queue from which to pop items (of type **:queue.queue()**).\n  - **n**: The number of items to retrieve (non-negative integer).","ref":"OffBroadwayWebSocket.Utils.html#pop_n/2-parameters"},{"type":"function","title":"Returns - OffBroadwayWebSocket.Utils.pop_n/2","doc":"- A tuple **{count, items, new_queue}** where:\n    - **count** is the actual number of items popped from the queue (non-negative integer).\n    - **items** is a list of the retrieved items.\n    - **new_queue** is the queue after items have been popped.","ref":"OffBroadwayWebSocket.Utils.html#pop_n/2-returns"},{"type":"function","title":"OffBroadwayWebSocket.Utils.put_with_nil/3","doc":"Conditionally adds a key-value pair to a map if the value is not **nil**.\n\nIf the provided value is **nil**, the function returns the original map without modification.\nOtherwise, it adds the key-value pair to the map.","ref":"OffBroadwayWebSocket.Utils.html#put_with_nil/3"},{"type":"function","title":"Parameters - OffBroadwayWebSocket.Utils.put_with_nil/3","doc":"- **opts**: The initial map to which the key-value pair may be added.\n  - **name**: The key to add to the map if **add_opts** is not **nil**.\n  - **add_opts**: The value to associate with **name**. If **nil**, **opts** is returned unmodified.","ref":"OffBroadwayWebSocket.Utils.html#put_with_nil/3-parameters"},{"type":"function","title":"Returns - OffBroadwayWebSocket.Utils.put_with_nil/3","doc":"- The updated map if **add_opts** is not **nil**.\n  - The original map if **add_opts** is **nil**.","ref":"OffBroadwayWebSocket.Utils.html#put_with_nil/3-returns"}],"producer":{"name":"ex_doc","version":"0.35.1"},"proglang":"elixir","content_type":"text/markdown"}